//===============================================================
// Lawson Labs, Inc.
// 3217 Phoenixville Pike
// Malvern, PA  19355
// 800 321-5355 or 610-725-8800
//-----------------------------
// Programmer: Tim Van Dusen
// Last modified: 4-30-01
// Name: VC5_APP.h
//===============================================================


#include <windows.h>
#include <winnt.h>
#include <wtypes.h>

//3-26-18
BYTE fGotDevError_global = false;





//***************************************************************
//*-------- M  A  C  R  O  S ------------------------------------\
//****************************************************************\
//================================================================*\
//=================================================================*>
//================================================================*/
/*****************************************************************/
// Variables used in macros (and elsewhere in code).
//3-21-01 HANDLE	hOutCon, hInCon;
//12-18-17 HWND	hOutCon, hInCon;
HANDLE	hOutCon, hInCon;
COORD	pos, dwCursorPosition;
CONSOLE_CURSOR_INFO	ConsoleCursorInfo;
CONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo;
DWORD	lpNumberOfCharsWritten;

#define gotoxy(x, y) pos.X = x; pos.Y = y - 1;	\
SetConsoleCursorPosition(hOutCon, pos);

#define clrscr() pos.X = 0; pos.Y = 0;		\
FillConsoleOutputCharacter(hOutCon, ' ',	\
80*25, pos, &lpNumberOfCharsWritten);

char ConBuff[512];
char* pConBuff = ConBuff;

#define WRITE_CON \
WriteConsole(hOutCon, pConBuff, strlen(ConBuff), \
&lpNumberOfCharsWritten, NULL);



#define CLEAR_MSG_LINE \
gotoxy(0,24); sprintf(ConBuff, "                                                                             "); WRITE_CON  \
gotoxy(0,24); 

#define LINE_CLEAR(x) \
gotoxy(0,x); sprintf(ConBuff,"                                                                                "); WRITE_CON


//###############################################################
//----N O N  -  S C A N    V  A  R  I  A  B  L  E  S -----------
//###############################################################
char cBigBuff[512];
USHORT usActiveDevID = 0;

BOOLEAN initDone = FALSE;
BOOLEAN fMasterDone = FALSE;
BOOLEAN fDevFoundDisplayDone = FALSE;
BOOLEAN fIsScanning = FALSE;

BOOLEAN fGotAnyConversion = FALSE;
DOUBLE dblLastConversion = 0;

BYTE bCurChan = 0;
BOOLEAN fChanSent = FALSE;

BYTE bDigin = 0;
BOOLEAN fDiginRead = FALSE;
BYTE bDigout = 0;
BOOLEAN fDigoutSent = 0;

BYTE fAnalogSent = 0;
DOUBLE dblLastAnalogOut = 0;
BYTE bDAC = 0;


BYTE bGotValidDev = 0;

BYTE bSendRateQuiet = 0;
DOUBLE dblRate = 100;
DOUBLE dblActualRate = 100;
BOOLEAN fRateSent = FALSE;

char binBuff[128];


//will need to memset all of these to 0
USHORT DevList[32];
USHORT DevListSave[32];
USHORT DevListNew[32];

#define SCRN_WIDTH 140
//#define SCRN_WIDTH 160







//###############################################################
//----  S C A N    V  A  R  I  A  B  L  E  S  -------------------\
//###############################################################
BYTE bScanType = 6;

BYTE bIsScanning = 0;			//Flags
BYTE bLocAvg = 1;
BYTE bNumChans = 7;				//for multi-channel scans
BYTE bNumChansTemp = 7;   // save multi-channel count when doing single chan    

BOOLEAN fCal = 1;					//Flags calibration scan
BOOLEAN fSingle = 0;			//Flags single channel scan
BOOLEAN fDig = 0;					//Flags digital input scan

BOOLEAN fDoLog = 0;				//Flags data file
BOOLEAN fDoScreen = 1;		//Flags screen writing

UINT uiScanNumber = 0;

#define NUMBER_OF_STRINGS 7
//stypestr = ["NUL", "SINGLE CHANNEL SCAN ", "MULTI-CHANNEL SCAN ", "MULTI-CHANNEL CAL SCAN ",
//		"SINGLE CHANNEL DIGIN SCAN ", "MULTI-CHANNEL DIGIN SCAN ", "MULTI-CHANNEL CAL DIGIN SCAN " ]
char *stypestr[NUMBER_OF_STRINGS] = {"NUL", "SINGLE CHANNEL SCAN ", "MULTI-CHANNEL SCAN ", "MULTI-CHANNEL CAL SCAN ",
										"SINGLE CHANNEL DIGIN SCAN ", "MULTI-CHANNEL DIGIN SCAN ", "MULTI-CHANNEL CAL DIGIN SCAN "};

#define CMND_SINGLE_CHAN_SCAN  0x1
#define CMND_MULTI_CHAN_SCAN  0x2 
#define CMND_MULTI_CHAN_CAL_SCAN  0x3 
#define CMND_SINGLE_CHAN_DIGIN_SCAN  0x4 
#define CMND_MULTI_CHAN_DIGIN_SCAN  0x5 
#define CMND_MULTI_CHAN_CAL_DIGIN_SCAN  0x6 

HANDLE hScanLogFile = 0;
FILE *fpScanLogFile = NULL;

char logFileBuff[1024];
DWORD dwGLOBAL_BytesWritten = 0;
#define logFileOut(x) WriteFile(hScanLogFile, x, strlen(x), &dwGLOBAL_BytesWritten, NULL)
char logFileName[255];


double dblAvgTot[8];
//AvgArray = array('f',[0])               // synthesized multi-channel array for averaging scan data
#define AVG_ARRAY_SIZE 255*8
//note that this might be best dynamically allocated with "NEW"
double dblAvgArray[AVG_ARRAY_SIZE];				// synthesized multi-channel array for averaging scan data







//****************************************************************\
//================================================================*\
//==== M I S C E L L A N E O U S  =================================*>
//================================================================*/
/*****************************************************************/

//HANDLE	hAppWindow, hLibM301CPP, hLibUSER32, hLibSETUPAPI;
HWND	hAppWindow;
HMODULE hLibLL_USB = NULL, hUnused = NULL;
HWND hMainWinDlg;

	

//***************************************************************
//*-------- L O C A L    F U N C T I O N S ----------------------\
//****************************************************************\

//================================================================*\
//==== NEW 12-2017 ================================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN toBinaryString(UINT uVal);
BOOLEAN stdscrAddstr(char* str);
BOOLEAN stdscrMove(BYTE y, BYTE x); //python reverses these from normal x/y format
BOOLEAN stdscrRefresh(void);
BOOLEAN stdscrClear(void);
BOOLEAN stdscrErase(UINT n);
BOOLEAN displayDevList(void);
BOOLEAN getDevList(void);
BOOLEAN getDevConnectStat();
BOOLEAN doInit(void);
BOOLEAN mainMenu(void);
BOOLEAN readConfig(void);


BOOLEAN createScanLog(void);
BOOLEAN setScanType(void);
BOOLEAN setNumScanChans(void);
BOOLEAN setLocalAvg(void);
BOOLEAN scanFunc(void);
BOOLEAN scanMenu(void);



//================================================================*\
//==== S C R E E N    M E N U S ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintMainMenuScreen(void);
BOOLEAN UserInputMenu_FUNCTIONS(void);
BOOLEAN PrintUtilityMenuScreen(void);
BOOLEAN PrintScanMenuScreen(void);
BOOLEAN UserInputMenu_MAIN(void);
BOOLEAN PrintFunctionMenuScreen(void);
BOOLEAN UserInputMenu_UTILITY(void);
BOOLEAN UserInputMenu_SCAN(void);


//****************************************************************\
//================================================================*\
//==== C O N S O L E   A N D  C U R S O R   H A N D L I N G =======*>
//================================================================*/
/*****************************************************************/
BOOLEAN SetupConsole(void);
VOID SetWin32CursorOn(void);
VOID SetWin32CursorOff(void);


//****************************************************************\
//================================================================*\
//==== L I B R A R Y    H A N D L I N G ===========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN LoadLibraries(void);
BOOLEAN CheckLibFuncs(void);




//***************************************************************
//*-------- I M P O R T E D    F U N C T I O N S ----------------\
//****************************************************************\
//================================================================*\
//=================================================================*>
//================================================================*/
/*****************************************************************/

//new 12-19-17
//BOOLEAN SP_GetRegDevList(USHORT* usCompleteDevList, UINT uiUnused);
typedef BOOLEAN(*P_GET_REG_DEV_LIST)
					(USHORT* usCompleteDevList, UINT uiUnused);
P_GET_REG_DEV_LIST SP_GetRegDevList = NULL;

//BOOLEAN SP_GetDevStat(USHORT usDevID, UINT* _uiDevStat)
typedef BOOLEAN(*P_GET_DEV_STAT)
					(USHORT usDevID, UINT* _uiDevStat);
P_GET_DEV_STAT SP_GetDevStat = NULL;

//BOOLEAN SP_CheckPower(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin, UINT* puiFlags)
typedef BOOLEAN(*P_CHECK_POWER)
					(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin, UINT* puiFlags);
P_CHECK_POWER SP_CheckPower = NULL;

//BOOLEAN EX_Connect(USHORT* usDevID)
typedef BOOLEAN(*P_EX_CONNECT)
					(USHORT* usDevID);
P_EX_CONNECT EX_Connect = NULL;

//BOOLEAN EX_ConnectOneDevice(USHORT usDevID, double pdblRate, BYTE bChan)
typedef BOOLEAN(*P_EX_CONNECT_ONE_DEVICE)
(USHORT usDevID, double pdblRate, BYTE bChan);
P_EX_CONNECT_ONE_DEVICE EX_ConnectOneDevice = NULL;


//BOOLEAN EX_SendRate(USHORT usDevID, double* dblRate)
typedef BOOLEAN(*P_EX_SEND_RATE)
					(USHORT usDevID, double* dblRate);
P_EX_SEND_RATE EX_SendRate = NULL;

//BOOLEAN EX_GetCalculatedRate(USHORT usDevID, double* dblRate)
typedef BOOLEAN(*P_EX_GET_CALCULATED_RATE)
					(USHORT usDevID, double* dblRate);
P_EX_GET_CALCULATED_RATE EX_GetCalculatedRate = NULL;

//BOOLEAN EX_SendChan(USHORT usDevID, BYTE bChan, BYTE* pbLastDigin)
typedef BOOLEAN(*P_EX_SEND_CHAN)
					(USHORT usDevID, BYTE bChan, BYTE* pbLastDigin);
P_EX_SEND_CHAN EX_SendChan = NULL;

//BOOLEAN EX_GetOneConversion(USHORT usDevID, double* dblMilliVolts)
typedef BOOLEAN(*P_EX_GET_ONE_CONVERSION)
					(USHORT usDevID, double* dblMilliVolts);
P_EX_GET_ONE_CONVERSION EX_GetOneConversion = NULL;

//BOOLEAN BOOLEAN EX_GetDigin(USHORT usDevID, BYTE* bDigIn)
typedef BOOLEAN(*P_EX_GET_DIGIN)
					(USHORT usDevID, BYTE* bDigIn);
P_EX_GET_DIGIN EX_GetDigin = NULL;


//BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut)
typedef BOOLEAN(*P_EX_SEND_DIGOUT)
					(USHORT usDevID, BYTE bDigOut);
P_EX_SEND_DIGOUT EX_SendDigout = NULL;

//BOOLEAN EX_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
typedef BOOLEAN(*P_EX_SEND_DAC)
					(USHORT usDevID, double dblVoltage, BYTE bDAC);
P_EX_SEND_DAC EX_SendDAC = NULL;

//BOOLEAN SP_SystemCalibration(USHORT usDevID, BYTE bCurChan)
typedef BOOLEAN(*P_SP_SYSTEM_CALIBRATION)
					(USHORT usDevID, BYTE bCurChan);
P_SP_SYSTEM_CALIBRATION SP_SystemCalibration = NULL;

//BOOLEAN SP_ResetDevice(USHORT usDevID)
typedef BOOLEAN(*P_SP_RESET_DEVICE)
					(USHORT usDevID);
P_SP_RESET_DEVICE SP_ResetDevice = NULL;

//BOOLEAN EX_SetScanType ( USHORT usDevID, BYTE bScanType );
typedef BOOLEAN(*P_EX_SET_SCAN_TYPE)
					(USHORT usDevID, BYTE bScanType);
P_EX_SET_SCAN_TYPE EX_SetScanType = NULL;

//BOOLEAN EX_SetDataLogOptions ( USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc );
typedef BOOLEAN(*P_EX_SET_DATA_LOG_OPTIONS)
					(USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc);
P_EX_SET_DATA_LOG_OPTIONS EX_SetDataLogOptions = NULL;

//BOOLEAN EX_SetMultiChanScanChans ( USHORT usDevID, BYTE bChanCnt ); 
typedef BOOLEAN(*P_EX_SET_MULTICHAN_SCAN_CHANS)
					(USHORT usDevID, BYTE bNumChans);
P_EX_SET_MULTICHAN_SCAN_CHANS EX_SetMultiChanScanChans = NULL;

//EX_Run ( USHORT usDevID );
typedef BOOLEAN(*P_EX_RUN)
					(USHORT usDevID);
P_EX_RUN EX_Run = NULL;

//EX_CheckScanStatus ( USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode)
typedef BOOLEAN(*P_EX_CHECK_SCAN_STATUS)
					(USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode);
P_EX_CHECK_SCAN_STATUS EX_CheckScanStatus = NULL;

//BOOLEAN EX_GetScanDataDblDigin ( USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff,
//                                UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned,
//                                UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiErrCode); 
typedef BOOLEAN(*P_EX_GET_SCAN_DATA_DBL_DIGIN)
					(USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff,
                                UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned,
                                UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiErrCode);
P_EX_GET_SCAN_DATA_DBL_DIGIN EX_GetScanDataDblDigin = NULL;

//BOOLEAN EX_GetScanDataDbl(USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested,
//                            UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning,
//                            UINT* puiTotalBuffSize, UINT* puiErrCode)
typedef BOOLEAN(*P_EX_GET_SCAN_DATA_DBL)
					(USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested,
                            UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning,
                            UINT* puiTotalBuffSize, UINT* puiErrCode);
P_EX_GET_SCAN_DATA_DBL EX_GetScanDataDbl = NULL;

//BOOLEAN EX_Stop ( USHORT usDevID ); 
typedef BOOLEAN(*P_EX_STOP)
					(USHORT usDevID);
P_EX_STOP EX_Stop = NULL;

//BOOLEAN EX_StopComplete ( USHORT usDevID );
typedef BOOLEAN(*P_EX_STOP_COMPLETE)
					(USHORT usDevID);
P_EX_STOP_COMPLETE EX_StopComplete = NULL;


//3-26-18
//BOOLEAN DLL_ReleaseDeviceFromIDList(USHORT *LLABS_DeviceIDRemoveList, BOOLEAN fReleaseAnyHandle)
#define FREE_ANY_DEV TRUE
#define FREE_ONLY_APP_OWNED_DEVICES FALSE
typedef BOOLEAN(*P_DLL_RELEASE_DEVICE_FROM_ID_LIST)
(USHORT* uspDeviceIDRemoveList, BOOLEAN fReleaseAnyHandle);
P_DLL_RELEASE_DEVICE_FROM_ID_LIST DLL_ReleaseDeviceFromIDList = NULL;

//3-26-18
//BOOLEAN DLL_ReInitOneDev(USHORT usDevID)
typedef BOOLEAN(*P_DLL_REINIT_ONE_DEV)
					(USHORT usDevID);
P_DLL_REINIT_ONE_DEV DLL_ReInitOneDev = NULL;

//BOOLEAN SP_ResetDevice(USHORT usDevID)
//typedef BOOLEAN(*P_SP_RESET_DEVICE)
//					(USHORT usDevID);
//P_SP_RESET_DEVICE SP_ResetDevice = NULL;
//

















//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
//############################################################################
// NOTE TO PROGRAMMER: See DLL Function call explanations 
//   in FuncDesc.doc. Can be viewed with Windows WordPad.
//----------\
//----------->
//----------/
typedef BOOLEAN(*P_DLL_INIT)
					(HWND _hAppMainWin, HMODULE hUnused, HMODULE hUnused2,
					SHORT sDebugLevel, BYTE* bNumDevicesShared, BYTE *pbUnusedVar,
					USHORT *usLLABS_DeviceIDList);
P_DLL_INIT pDLL_Init = NULL;
//----------\
//----------->
//----------/	
typedef BOOLEAN(*P_DLL_GET_DEVICE_ID_LIST)(void);
P_DLL_GET_DEVICE_ID_LIST pDLL_GetDeviceIDList = NULL;
//----------\
//----------->
//----------/
#define fDO_DISP_VER		TRUE
#define fDONT_DISP_VER	FALSE	

typedef BOOLEAN(*P_DLL_GET_VERSION_INFO)(USHORT usDevID, BOOLEAN fDisplayVersion, 
						USHORT* usDevVersion, char* cpDLLVersion, char* cpDrvrVersion);
P_DLL_GET_VERSION_INFO pDLL_GetVersionInfo = NULL;
//----------\
//----------->
//----------/	
typedef BOOLEAN(*P_DLL_RESET_DEVICE)(USHORT usDevID, BYTE bReserved);
P_DLL_RESET_DEVICE pDLL_ResetDevice = NULL;
//----------\
//----------->
//----------/	
// NOTE: See FuncDesc.doc for more information regarding this function.
typedef BOOLEAN(*P_DLL_INSTANCE_INIT_DEVICE_LIST)(BOOLEAN fShowLists);
P_DLL_INSTANCE_INIT_DEVICE_LIST pDLL_InstanceInitDeviceList = NULL;
//----------\
//----------->
//----------/
// NOTE: See FuncDesc.doc for more information regarding this function.
//#define FREE_ANY_DEV TRUE
//#define FREE_ONLY_APP_OWNED_DEVICES FALSE
//typedef BOOLEAN(*P_DLL_RELEASE_DEVICE_FROM_IDLIST)
//		(USHORT* usLLABS_DeviceIDToRelease, BOOLEAN fAnyHandle);
//P_DLL_RELEASE_DEVICE_FROM_IDLIST pDLL_ReleaseDeviceFromIDList = NULL;
//----------\
//----------->
//----------/
//typedef BOOLEAN(*P_DLL_SET_RATE)(USHORT usDevID, DOUBLE dblRate);
//P_DLL_SET_RATE  pDLL_SetRate = NULL;
typedef BOOLEAN(*P_DLL_SET_RATE)(USHORT usDevID, DOUBLE dblRate);
P_DLL_SET_RATE  pDLL_SetRate = NULL;
//----------\
//----------->
//----------/
typedef BOOLEAN (*P_DLL_READ_WRITE_ONE_DEVICE)(BOOLEAN fReadWrite, 
        BYTE* pDynamicArray, USHORT usDevID, UINT* pNumBytesToRead, 
		  BYTE* pbDigIn, UINT ulTimeOut);
P_DLL_READ_WRITE_ONE_DEVICE pDLL_ReadWriteOneDevice = NULL;


 
